/*
 * ya_nsis.c
 * Copyright (C) 2015-2016 Peter Belkner <pbelkner@snafu.de>
 *
 * This file is part of libya.
 *
 * libya is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libya is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with libya.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <ya.h>
#if 0 // {
// http://forums.winamp.com/showthread.php?postid=1692707
#include <nsis/pluginapi.h>

#if defined (wsprintf)
#undef wsprintf
#endif

void GetFileInfoW(const wchar_t *Filename, const wchar_t *InfoProperty)
{
  void *pInfo;
  void *pInfoData;
  DWORD dwInfoSize;
  DWORD dwLen;

  struct {
    WORD wLanguage;
    WORD wCodePage;
  } *pLangPtr;

  /* just needs to be long enough for fixed length + InfoProperty */
  wchar_t wszInfoType[256];
  wchar_t *pwszResult = NULL;

  if ((dwInfoSize=GetFileVersionInfoSizeW(Filename,&dwLen))<0) {
    DMESSAGE("getting nsis file version info size");
    goto size;
  }

  if (NULL==(pInfo=GlobalAlloc(GMEM_FIXED,dwInfoSize))) {
    DMESSAGE("allocating nsis file info");
    goto alloc;
  }

  if (0==GetFileVersionInfoW(Filename,0,dwInfoSize,pInfo)) {
    DMESSAGE("getting nsis file info");
    goto info;
  }

  if (0==VerQueryValueW(pInfo,L"\\VarFileInfo\\Translation",
      &pLangPtr,&dwLen)) {
    DMESSAGE("querying nsis original file info");
    goto original;
  }

  wsprintf(wszInfoType,L"\\StringFileInfo\\%04X%04X\\%s",pLangPtr->wLanguage,
      pLangPtr->wCodePage,InfoProperty);

  if (0==VerQueryValueW(pInfo,wszInfoType,&pInfoData,&dwLen)) {
    DMESSAGE("querying nsis translated file info");
    goto translate;
  }

  /* copy results onto NSIS stack prior to deallocating memory it points to */
  PushStringW(NULL==(pwszResult=pInfoData)?L"":pwszResult);
translate:
original:
info:
  GlobalFree(pInfo);
alloc:
size:
  return;
}

#if 0 // {
void CommonInit(HWND hwndParent, int string_size, TCHAR *variables, stack_t **stacktop, TCHAR const *InfoProperty)
{
  TCHAR *TempFileName;
  TCHAR *TempInfoProperty = NULL;

  EXDLL_INIT();
  if ((TempFileName = GlobalAlloc(GMEM_FIXED, string_size)) != NULL)
  {
    popstring(TempFileName);

	/* if InfoProperty not provided then pop from NSIS stack */
	if (InfoProperty == NULL)
	{
	  if ((TempInfoProperty = GlobalAlloc(GMEM_FIXED, string_size)) != NULL)
	  {
	    popstring(TempInfoProperty);
	    InfoProperty = TempInfoProperty;
	  }
	}

	/* retrieve the resource information */
    GetFileInfo(TempFileName, InfoProperty);

	/* free memory allocated */
	if (TempInfoProperty != NULL)
	  GlobalFree(TempInfoProperty);
    if (TempFileName != NULL)
      GlobalFree(TempFileName);
  }
  else
  {
    pushstring(_T(""));
  }
}
#else // } {
void CommonInit(HWND hwndParent, int string_size, wchar_t *variables,
    stack_t **stacktop, const wchar_t *InfoProperty)
{
  TCHAR *TempFileName;
  TCHAR *TempInfoProperty = NULL;

  EXDLL_INIT();

  if ((TempFileName = GlobalAlloc(GMEM_FIXED, string_size)) != NULL)
  {
    popstring(TempFileName);

	/* if InfoProperty not provided then pop from NSIS stack */
	if (InfoProperty == NULL)
	{
	  if ((TempInfoProperty = GlobalAlloc(GMEM_FIXED, string_size)) != NULL)
	  {
	    popstring(TempInfoProperty);
	    InfoProperty = TempInfoProperty;
	  }
	}

	/* retrieve the resource information */
    GetFileInfo(TempFileName, InfoProperty);

	/* free memory allocated */
	if (TempInfoProperty != NULL)
	  GlobalFree(TempInfoProperty);
    if (TempFileName != NULL)
      GlobalFree(TempFileName);
  }
  else
  {
    pushstring(_T(""));
  }
}
#endif // }
#endif // }
